<?php
class iPay_PaymentGateway_PaymentController extends Mage_Core_Controller_Front_Action 
{
  public function gatewayAction() 
  {
    if ($this->getRequest()->get("orderId"))
    {
      $arr_querystring = array(
        'flag' => 1, 
        'orderId' => $this->getRequest()->get("orderId")
      );
       
      Mage_Core_Controller_Varien_Action::_redirect('paymentgateway/payment/response', array('_secure' => false, '_query'=> $arr_querystring));
    }
  }
   
  public function redirectAction() 
  {
    $this->loadLayout();
    $block = $this->getLayout()->createBlock('Mage_Core_Block_Template','paymentgateway',array('template' => 'paymentgateway/redirect.phtml'));
    $this->getLayout()->getBlock('content')->append($block);
    $this->renderLayout();
  }
 
  public function responseAction() 
  {
    if ($this->getRequest()->get("flag") == "1" && $this->getRequest()->get("orderId")) 
    {
      $orderId = $this->getRequest()->get("orderId");
      $order = Mage::getModel('sales/order')->loadByIncrementId($orderId);
      $order->setState(Mage_Sales_Model_Order::STATE_PAYMENT_REVIEW, true, 'Payment Success.');
      $order->save();
       
      Mage::getSingleton('checkout/session')->unsQuoteId();
      Mage_Core_Controller_Varien_Action::_redirect('checkout/onepage/success', array('_secure'=> false));
    }
    else
    {
      Mage_Core_Controller_Varien_Action::_redirect('checkout/onepage/error', array('_secure'=> false));
    }
  }

  public function callbackAction()
  {


    $val = Mage::getStoreConfig('payment/paymentgateway/vendorid'); #Assigned iPay Vendor ID. Hard code it here.
      /*
      These values below are picked from the incoming URL and assigned to variables that we 
      will use in our security check URL
      */
      $val1 = $_GET['id']; 
      $val2 = $_GET['ivm'];
      $val3 = $_GET['qwh'];
      $val4 = $_GET['afd'];
      $val5 = $_GET['poi'];
      $val6 = $_GET['uyt'];
      $val7 = $_GET['ifd'];
      $merchant_order_id = $_GET['id'];

      // echo $val1;

      $ipnurl= "https://ipayafrica.com/ipn/?vendor=".$val."&id=".$val1."&ivm=".
      $val2."&qwh=".$val3."&afd=".$val4."&poi=".$val5."&uyt=".$val6."&ifd=".$val7; 

      if($val == "demo"){
        $status = "aei7p7yrx4ae34";
      }
      else{
        $fp = fopen($ipnurl, "rb");
        $status = stream_get_contents($fp, -1, -1);
        fclose($fp);
      }


      $session = Mage::getSingleton('checkout/session');
      $session->setQuoteId($merchant_order_id);
      
      Mage::getSingleton('checkout/session')->getQuote()->setIsActive(false)->save();

      $order = Mage::getModel('sales/order');
      $order->loadByIncrementId($session->getLastRealOrderId());


      if ($status == 'fe2707etr5s4wq') {
        
        //FAILED
        $order->setState(Mage_Sales_Model_Order::STATE_CANCELED,true)->save();
        $order->save();
        
        Mage_Core_Controller_Varien_Action::_redirect('checkout/onepage/failure', array('_secure'=> false));

      }elseif ($status == 'aei7p7yrx4ae34') {
        
        //SUCCESSFUL
        $order->setState(Mage_Sales_Model_Order::STATE_PROCESSING,true)->save();
        $order->save();
        
        Mage_Core_Controller_Varien_Action::_redirect('checkout/onepage/success', array('_secure'=> false));

      }elseif ($status == 'bdi6p2yy76etrs') {
        
        // PENDING
        $order->setState(Mage_Sales_Model_Order::STATE_PENDING_PAYMENT,true)->save();
        $order->save();
        
        Mage_Core_Controller_Varien_Action::_redirect('checkout/onepage/failure', array('_secure'=> false));

      }elseif ($status == 'cr5i3pgy9867e1') {
        
        //USED CODE 
        $order->setState(Mage_Sales_Model_Order::STATE_CANCELED,true)->save();
        $order->save();
        
        Mage_Core_Controller_Varien_Action::_redirect('checkout/onepage/failure', array('_secure'=> false));

      }elseif ($status == 'dtfi4p7yty45wq') {
        
        // Less
        $order->setState(Mage_Sales_Model_Order::STATE_CANCELED,true)->save();
        $order->save();
        
        Mage_Core_Controller_Varien_Action::_redirect('checkout/onepage/failure', array('_secure'=> false));


      }elseif ($status == 'eq3i7p5yt7645e') {

        // More
        $order->setState(Mage_Sales_Model_Order::STATE_PROCESSING,true)->save();
        $order->save();
        
        Mage_Core_Controller_Varien_Action::_redirect('checkout/onepage/success', array('_secure'=> false));
        
      }
  }
}